<script setup>
/* the computed todo list requires compute from vue */
import { ref, computed } from 'vue';
/* id to track to do items */
let id = 0;

/* new list items */
const newTodo = ref('');

/* flag to toggle hiding completed list items */
const hideCompleted = ref(false);

/* list of todos */
const todos = ref([
   { id: id++, text: 'Learn HTML', done: true },
   { id: id++, text: 'Learn JavaScript', done: true },
   { id: id++, text: 'Learn Vue', done: false },
]);

/* filtered list of todos */
const filteredTodos = computed(() => {
   // return filtered todos based on
   // `todos.value` & `hideCompleted.value`
   /* if hideCompleted is true... */
   return hideCompleted.value
      ? /* return the todo array, filtered by if done is false (not done, thus we show it) */
        todos.value.filter((t) => !t.done)
      : /* else just send back the complete array */
        todos.value;
});

/* add a new todo to the todo list */
function addTodo() {
   /* when adding a new todo, increment the id, take the text from the
   input field and set that to the newTodo.value, and default done to false */
   todos.value.push({ id: id++, text: newTodo.value, done: false });
   /* clear newTodo */
   newTodo.value = '';
}

/* remove a todo from the todo list */
function removeTodo(todo) {
   /* Using filter, we set the value of the todo array
   to a filtered todo array that removes the specific
   todo object we sent back in the click event.*/
   todos.value = todos.value.filter((t) => t !== todo);
}
</script>

<template>
   <!-- Toggle display of a tag via a
   truthy/falsey toggle method     -->
   <div class="card">
      <div class="block card-header">
         <h2 class="card-header-title">Learning Module 6</h2>
      </div>
      <div class="block card-header">
         <h2 class="subtitle is-4">
            - Use the list from Module 5 and add a computed property
            using computed()
         </h2>
         <br />
      </div>
      <div class="card-content">
         <form @submit.prevent="addTodo" class="block tag is-size-4">
            <input v-model="newTodo" class="input" />
            &ThinSpace;
            <button class="button is-primary">Add Todo</button>
         </form>
         <ul class="block">
            <li
               class="block"
               v-for="todo in filteredTodos"
               :key="todo.id"
            >
               <div class="tag is-size-6">
                  <input
                     type="checkbox"
                     class="checkbox is-size-6"
                     v-model="todo.done"
                  />&ThinSpace;
                  <span :class="{ done: todo.done }">{{
                     todo.text
                  }}</span>
               </div>
               <button
                  class="button is-small is-danger"
                  @click="removeTodo(todo)"
               >
                  X
               </button>
            </li>
         </ul>
         <button
            @click="hideCompleted = !hideCompleted"
            class="button is-warning block"
         >
            {{ hideCompleted ? 'Show all' : 'Hide completed' }}
         </button>
      </div>
   </div>
</template>
